/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatLookupControllerActionAttributeRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatLookupControllerActionAttributeRequest{}

// SnapchatLookupControllerActionAttributeRequest struct for SnapchatLookupControllerActionAttributeRequest
type SnapchatLookupControllerActionAttributeRequest struct {
	Level *string `json:"level,omitempty"`
}

// NewSnapchatLookupControllerActionAttributeRequest instantiates a new SnapchatLookupControllerActionAttributeRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatLookupControllerActionAttributeRequest() *SnapchatLookupControllerActionAttributeRequest {
	this := SnapchatLookupControllerActionAttributeRequest{}
	return &this
}

// NewSnapchatLookupControllerActionAttributeRequestWithDefaults instantiates a new SnapchatLookupControllerActionAttributeRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatLookupControllerActionAttributeRequestWithDefaults() *SnapchatLookupControllerActionAttributeRequest {
	this := SnapchatLookupControllerActionAttributeRequest{}
	return &this
}

// GetLevel returns the Level field value if set, zero value otherwise.
func (o *SnapchatLookupControllerActionAttributeRequest) GetLevel() string {
	if o == nil || IsNil(o.Level) {
		var ret string
		return ret
	}
	return *o.Level
}

// GetLevelOk returns a tuple with the Level field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupControllerActionAttributeRequest) GetLevelOk() (*string, bool) {
	if o == nil || IsNil(o.Level) {
		return nil, false
	}
	return o.Level, true
}

// HasLevel returns a boolean if a field has been set.
func (o *SnapchatLookupControllerActionAttributeRequest) HasLevel() bool {
	if o != nil && !IsNil(o.Level) {
		return true
	}

	return false
}

// SetLevel gets a reference to the given string and assigns it to the Level field.
func (o *SnapchatLookupControllerActionAttributeRequest) SetLevel(v string) {
	o.Level = &v
}

func (o SnapchatLookupControllerActionAttributeRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatLookupControllerActionAttributeRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Level) {
		toSerialize["level"] = o.Level
	}
	return toSerialize, nil
}

type NullableSnapchatLookupControllerActionAttributeRequest struct {
	value *SnapchatLookupControllerActionAttributeRequest
	isSet bool
}

func (v NullableSnapchatLookupControllerActionAttributeRequest) Get() *SnapchatLookupControllerActionAttributeRequest {
	return v.value
}

func (v *NullableSnapchatLookupControllerActionAttributeRequest) Set(val *SnapchatLookupControllerActionAttributeRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatLookupControllerActionAttributeRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatLookupControllerActionAttributeRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatLookupControllerActionAttributeRequest(val *SnapchatLookupControllerActionAttributeRequest) *NullableSnapchatLookupControllerActionAttributeRequest {
	return &NullableSnapchatLookupControllerActionAttributeRequest{value: val, isSet: true}
}

func (v NullableSnapchatLookupControllerActionAttributeRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatLookupControllerActionAttributeRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
